/*
 * UnaryFunctionTest.java
 *
 * Created on 28. \u0159\u00edjen 2006, 17:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.functions;

import junit.framework.TestCase;

/**
 *
 * @author petr
 */
public class UnaryFunctionTest extends TestCase {

    void assertFunction(UnaryFunction function, double delta,
            double[] xValues, double[] yValues) {
        
        for(int i = 0; i < xValues.length; i++) {
            if (Double.isNaN(yValues[i])) {
                assertFalse("Funkce [" + function + "] by pro hodnotu x = " + 
                        xValues[i] + " m\u011bla b\u00fdt nedefinov\u00e1na, av\u0161ak metoda " +
                        "isDefinedFor(double x) vrac\u00ed true",
                        function.isDefinedFor(xValues[i]));
                assertTrue("Funkce [" + function + "] by pro hodnotu x = " + 
                        xValues[i] + " m\u011bla vracet hodnotu NaN", 
                        Double.isNaN(function.getValue(xValues[i])));
            } else {
                assertTrue("Funkce [" + function + "] by pro hodnotu x = " + 
                        xValues[i] + " m\u011bla b\u00fdt definov\u00e1na, av\u0161ak metoda " +
                        "isDefinedFor(double x) vrac\u00ed false",
                        function.isDefinedFor(xValues[i]));
                assertEquals("Funkce [" + function + "] nevrac\u00ed pro hodnotu x = " +
                    xValues[i] + " o\u010dek\u00e1vanou hodnotu y",
                    yValues[i],function.getValue(xValues[i]), delta);
            }
        }
    }
    
    public void testSimpleSinus() {
        UnaryFunction simpleSinus = new SinusFunction(1,1);
        assertEquals("1.0 * sin(1.0 * x)",simpleSinus.toString());
        assertFunction(simpleSinus,0.00001,
                new double[] {-2 * Math.PI, -Math.PI, -1, 0, 1, Math.PI/2, Math.PI},
                new double[] { 0, 0, -0.84147, 0, 0.84147, 1, 0});
    }

    public void testSinusA() {
        UnaryFunction simpleSinus = new SinusFunction(2,1);
        assertEquals("2.0 * sin(1.0 * x)",simpleSinus.toString());
        assertFunction(simpleSinus,0.00001,
                new double[] {-2 * Math.PI, -Math.PI, -1, 0, 1, Math.PI/2, Math.PI},
                new double[] { 0, 0, -1.68294, 0, 1.68294, 2, 0});
    }

    public void testSinusB() {
        UnaryFunction simpleSinus = new SinusFunction(1,2);
        assertEquals("1.0 * sin(2.0 * x)",simpleSinus.toString());
        assertFunction(simpleSinus,0.00001,
                new double[] {-Math.PI, -Math.PI/2, -0.5, 0, 0.5, Math.PI/4, Math.PI/2},
                new double[] { 0, 0, -0.84147, 0, 0.84147, 1, 0});
    }

    public void testSinusAB() {
        UnaryFunction simpleSinus = new SinusFunction(2,2);
        assertEquals("2.0 * sin(2.0 * x)",simpleSinus.toString());
        assertFunction(simpleSinus,0.00001,
                new double[] {-Math.PI, -Math.PI/2, -0.5, 0, 0.5, Math.PI/4, Math.PI/2},
                new double[] { 0, 0, -1.68294, 0, 1.68294, 2, 0});
    }

    public void testSquareRoot() {
        UnaryFunction squareRoot = new SquareRootFunction();
        assertEquals("sqrt(x)",squareRoot.toString());
        final double NaN = Double.NaN;
        assertFunction(squareRoot,0.00001,
                new double[] {-10, -1, -Double.MIN_VALUE, 0, Double.MIN_VALUE, 1, 2, 4, 16},
                new double[] { NaN, NaN, NaN, 0, 2.22E-162, 1, 1.41421, 2, 4});
    }

    public void testPolynomialZero() {
        UnaryFunction polynomial = new PolynomialFunction(0);
        assertEquals("0",polynomial.toString());
        assertFunction(polynomial,0.00001,
                new double[] { -10, -1, -Double.MIN_VALUE, 0, Double.MIN_VALUE, 1, 10},
                new double[] { 0, 0, 0, 0, 0, 0, 0});
    }

    public void testPolynomialConst() {
        UnaryFunction polynomial = new PolynomialFunction(Math.E);
        assertEquals("2.718281828459045",polynomial.toString());
        assertFunction(polynomial,0.00001,
                new double[] { -10, -1, -Double.MIN_VALUE, 0, Double.MIN_VALUE, 1, 10},
                new double[] { Math.E, Math.E, Math.E, Math.E, Math.E, Math.E, Math.E});
    }

    public void testPolynomialLinear() {
        UnaryFunction polynomial = new PolynomialFunction(2,3);
        assertEquals("2.0 + (3.0 * x^1)",polynomial.toString());
        assertFunction(polynomial,0.00001,
                new double[] { -10, -1, -Double.MIN_VALUE, 0, Double.MIN_VALUE, 1, 10},
                new double[] { -28, -1, 2, 2, 2, 5, 32});
    }

    public void testPolynomialSquare() {
        UnaryFunction polynomial = new PolynomialFunction(2,3,4);
        assertEquals("2.0 + (3.0 * x^1) + (4.0 * x^2)",polynomial.toString());
        assertFunction(polynomial,0.00001,
                new double[] { -10, -1, -Double.MIN_VALUE, 0, Double.MIN_VALUE, 1, 10},
                new double[] { 372, 3, 2, 2, 2, 9, 432});
    }
  
    public void testPolynomialCubic() {
        UnaryFunction polynomial = new PolynomialFunction(2,3,4,5);
        assertEquals("2.0 + (3.0 * x^1) + (4.0 * x^2) + (5.0 * x^3)",polynomial.toString());
        assertFunction(polynomial,0.00001,
                new double[] { -10, -1, -Double.MIN_VALUE, 0, Double.MIN_VALUE, 1, 10},
                new double[] { -4628, -2, 2, 2, 2, 14, 5432});
    }

    public void testPolynomialMisc() {
        assertEquals("(3.0 * x^1) + (4.0 * x^2) + (5.0 * x^3)",
                new PolynomialFunction(0,3,4,5).toString());
        
        assertEquals("2.0 + (4.0 * x^2) + (5.0 * x^3)",
                new PolynomialFunction(2,0,4,5).toString());
        
        assertEquals("2.0 + (3.0 * x^1) + (5.0 * x^3)",
                new PolynomialFunction(2,3,0,5).toString());
        
        assertEquals("2.0 + (5.0 * x^3)",
                new PolynomialFunction(2,0,0,5).toString());
        
        assertEquals("(5.0 * x^3)",
                new PolynomialFunction(0,0,0,5).toString());
    }
}
